Status: Needs Feedback Priority: Should have
Author: Alexander Schnitzler Category: Fluid
Created: 2015-02-14 Assigned To: Alexander Schnitzler
Updated: 2015-07-11 Due date:
TYPO3 Version: 7
PHP Version:
Complexity: easy
Is Regression: No
Sprint Focus:
Subject: SelectViewHelper doesn't handle optionValueField and optionLabelField for array options
Description

<f:form.select options="{array}" optionValueField="uid" optionLabelField="title" />

should work with the given array:
array(
    array(
        'uid' => 1,
        'title' => 'Foo'
    ),
    array(
        'uid' => -1,
        'title' => 'Bar'
    ),
    array(
        'title' => 'Baz'
    ),
    array(
        'uid' => '2'
    ),
)

Currently fluid tries to use the keys as values and the arrays as label which results in an error.

Related issues:
related to TYPO3.Fluid - Bug # 65424: SelectViewHelper must respect  option(V... Under Review 2015-02-28
related to powermail - Bug # 65792: No identifying value for object of class ... Resolved 2015-03-17
precedes Sphinx Python Documentation Generator - Bug # 65487: PHP Warning whe... Closed 2015-03-03

Associated revisions
Revision 968ed7f4 - 2015-02-28 21:46 - Alexander Schnitzler 

[BUGFIX] SelectViewHelper must respect option(Value|Label)Field for arrays

The SelectViewHelper tries to resolve the value and label
field as long as options are of type object, i.e. domain
objects but that functionality must also exist for arrays
because their structure is similar to objects.

2015-08-04 1/4



Example:
<f:form.select
    options="{items}" 
    optionValueField="uid" 
    optionLabelField="title" 
/>

$items = array(
    0 => array(
        'uid' => 1,
        'title' => 'Foo'
    ),
);

Currently the view helper tries to use the array key as
value field (i.e. 0) and the array value (i.e. array) as
label and fails calling htmlspecialchars on the array.

This patch allows values to be arrays themselves and to
be treated like domain objects.

Resolves: #65073
Releases: master, 6.2
Change-Id: Ia803ceb38c1f7488d48863f5a6781b229def50c4
Reviewed-on: http://review.typo3.org/36909
Reviewed-by: Stefan Froemken <froemken@gmail.com>
Tested-by: Stefan Froemken <froemken@gmail.com>
Tested-by: Andy Grunwald <andygrunwald@gmail.com>
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Revision 6bc5d5b4 - 2015-02-28 21:47 - Alexander Schnitzler 

[BUGFIX] SelectViewHelper must respect option(Value|Label)Field for arrays

The SelectViewHelper tries to resolve the value and label
field as long as options are of type object, i.e. domain
objects but that functionality must also exist for arrays
because their structure is similar to objects.

Example:
<f:form.select
    options="{items}" 
    optionValueField="uid" 
    optionLabelField="title" 
/>

$items = array(
    0 => array(
        'uid' => 1,
        'title' => 'Foo'
    ),
);

Currently the view helper tries to use the array key as
value field (i.e. 0) and the array value (i.e. array) as
label and fails calling htmlspecialchars on the array.

This patch allows values to be arrays themselves and to
be treated like domain objects.

Resolves: #65073
Releases: master, 6.2
Change-Id: Ia803ceb38c1f7488d48863f5a6781b229def50c4
Reviewed-on: http://review.typo3.org/37376
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

History
#1 - 2015-02-14 17:43 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36909

#2 - 2015-02-28 21:47 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37376

#3 - 2015-02-28 22:00 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:968ed7f4420b67e0811ef2126a8504cce44a8a6b.

#4 - 2015-02-28 22:22 - Stefan Neufeind

Also created an issue upstream at Flow-Fluid, #65424.

#5 - 2015-03-03 15:48 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37504
#6 - 2015-03-19 11:50 - Marcus Schwemer

Hi,

this breaks the current behavious as stated in post-verifies on Gerrit https://review.typo3.org/#/c/36909/

Another report is for powermail: #65792

IMO this change should be done in a non-breaking way or should be reverted.

Kind regards,
Marcus

#7 - 2015-06-15 17:08 - Benjamin Mack
- Target version changed from 7.1 (Cleanup) to 7.4 (Backend)

#8 - 2015-07-11 16:59 - Wouter Wolters
- Status changed from Under Review to Needs Feedback

Still something needed here? The patch is abandoned.
